/****************************************************************************

 MESSAGE PASSING INTERFACE TEST CASE SUITE

 Copyright IBM Corp. 1995

 IBM Corp. hereby grants a non-exclusive license to use, copy, modify, and
 distribute this software for any purpose and without fee provided that the
 above copyright notice and the following paragraphs appear in all copies.

 IBM Corp. makes no representation that the test cases comprising this
 suite are correct or are an accurate representation of any standard.

 In no event shall IBM be liable to any party for direct, indirect, special
 incidental, or consequential damage arising out of the use of this software
 even if IBM Corp. has been advised of the possibility of such damage.

 IBM CORP. SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED
 TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS AND IBM
 CORP. HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
 ENHANCEMENTS, OR MODIFICATIONS.

****************************************************************************

 These test cases reflect an interpretation of the MPI Standard.  They are
 are, in most cases, unit tests of specific MPI behaviors.  If a user of any
 test case from this set believes that the MPI Standard requires behavior
 different than that implied by the test case we would appreciate feedback.

 Comments may be sent to:
    Richard Treumann
    treumann@kgn.ibm.com

****************************************************************************

 MPI-Java version :
    Sung-Hoon Ko(shko@npac.syr.edu)
    Northeast Parallel Architectures Center at Syracuse University
    09/10/99

****************************************************************************
*/

import mpi.*;
 
class cancel {
    static public void main(String[] args) {
	
	int me,tasks,i;
	boolean flag;
	int data[] = new int[1];

	Request request;
	Status status;

	MPI.Init(args);

	me = MPI.COMM_WORLD.Rank();
	tasks=MPI.COMM_WORLD.Size();

	if(me == 0)  {
	    System.out.println("1111111 ");
	    
	    //MPI_Irecv(&data,1,MPI_INT,1,1,MPI_COMM_WORLD,&request);
	    request = MPI.COMM_WORLD.Irecv(data,0,1,MPI.INT,1,1);
	    System.out.println("22222222 ");
	    //MPI_Cancel(&request);
	    request.Cancel();  
	    System.out.println("3333 ");
	    //MPI_Wait(&request,&status);
	    status = request.Wait();
	    System.out.println("44444 ");
	    //MPI_Test_cancelled(&status,&flag);
	    flag = status.Test_cancelled();
	    System.out.println("55555 ");
	    if(!flag) System.out.println
			  ("task "+me+" ERROR: Receive request not cancelled!\n");
	    //MPI_Issend(&data,100000,MPI_INT,1,1,MPI_COMM_WORLD,&request);
	    request = MPI.COMM_WORLD.Issend(data,0,100000,MPI.INT,1,1);
	    //MPI_Cancel(&request);
	    System.out.println("66666 ");
	    request.Cancel();
	    System.out.println("77777 ");

	    /*	    
	    //for(flag=false;;)  {
	    for(;;)  {
	    System.out.println("00000 ");
		//MPI_Test(&request,&flag,&status);
		status = request.Test();
		//if(flag) break;
		if(status != null) break;
	    }
	    */

	    //MPI_Test_cancelled(&status,&flag);
	    flag = status.Test_cancelled();
	    System.out.println("88888 ");
	    if(!flag) System.out.println
			  ("task "+me+" ERROR: Send request not cancelled! (1)\n");
	    
	}

	MPI.COMM_WORLD.Barrier();
	if(me == 0)  {
	    System.out.println("aaaa ");
	    data[0] = 5;
	    //MPI_Isend(&data,1,MPI_INT,1,1,MPI_COMM_WORLD,&request);
	    request = MPI.COMM_WORLD.Isend(data,0,1,MPI.INT,1,1);
	    System.out.println("bbbb ");
	    //MPI_Cancel(&request);
	    request.Cancel();
	    System.out.println("ccccc ");
	    //MPI_Wait(&request,&status);
	    status = request.Wait();
	    System.out.println("dddd ");
	    //MPI_Test_cancelled(&status,&flag);
	    flag = status.Test_cancelled();
	    System.out.println("eeeee ");
	    if(!flag) System.out.println
			  ("task "+me+" ERROR: Send request not cancelled! (2)\n");

	    data[0] = 6;
	    //MPI_Send(&data,1,MPI_INT,1,5,MPI_COMM_WORLD);
	    MPI.COMM_WORLD.Send(data,0,1,MPI.INT,1,5);
	    System.out.println(" fffffff");
	    //MPI_Isend(&data,1,MPI_INT,1,1,MPI_COMM_WORLD,&request);
	    request = MPI.COMM_WORLD.Isend(data,0,1,MPI.INT,1,1);
	    System.out.println("gggg ");
	    MPI.COMM_WORLD.Barrier();
	    System.out.println("hhhh ");
	    //MPI_Cancel(&request);
	    request.Cancel();
	    System.out.println("iiii ");
	    //MPI_Wait(&request,&status);
	    status = request.Wait();
	    System.out.println("jjjjj ");
	    //MPI_Test_cancelled(&status,&flag);
	    flag = status.Test_cancelled();
	    if(!flag) System.out.println
			  ("task "+me+" ERROR: Send request cancelled!");
	    System.out.println("kkkkk ");
	} else if(me == 1) {
	    for(i=0;i<1000000;i++);
	    data[0] = 0;
	    System.out.println("11aaa ");
	    //MPI_Recv(&data,1,MPI_INT,0,1,MPI_COMM_WORLD,&status);
	    status = MPI.COMM_WORLD.Recv(data,0,1,MPI.INT,1,1);
	    System.out.println(" 22bb");
	    if(data[0] != 6) 
		System.out.println
		    ("task "+me+" ERROR: Send request not cancelled!");

	    //MPI_Recv(&data,1,MPI_INT,0,5,MPI_COMM_WORLD,&status);
	    status = MPI.COMM_WORLD.Recv(data,0,1,MPI.INT,0,5);
	    MPI.COMM_WORLD.Barrier();
	    System.out.println("33cc ");
	}
	MPI.COMM_WORLD.Barrier();
	if(me == 0)  System.out.println("Cancel TEST COMPLETE\n");
	MPI.Finalize();
	
    }
}

